#!/usr/local/bin/perl
##############################################
# MeySoft Banner Manager - Version 2.5F
# Revised May 12, 1998
# Copyright (c) 1998 MeySoft
# Author: Jeffrey L. Meyer, Sr.Programmer
# CGI@MeySoft.com
#
# THIS HEADER MUST REMAIN INTACT
################################

#  require 5.002;
#  require LWP;
#  use LWP::Simple;

# UNCOMMENT THE PREVIOUS 3 LINES TO USE LWP::mirror
# FOR UPLOADING INSTEAD OF Lynx.


require "config25.pl";
require "bm25fn.pl";
require "admlib.pl";
require "reports.pl";
require "conf.pl";


alarm(300);

@slist=split(/,/,$CFG{'slist'});

if($ENV{'REQUEST_METHOD'} eq 'POST'){
   read(STDIN,$data,$ENV{'CONTENT_LENGTH'});
 }else{
   $data="$ENV{'QUERY_STRING'}";
 }
@fields = split(/&/,$data);
foreach $fields(@fields){
  ($field_name,$field_val)=split(/=/,$fields);
  $field_val=~ tr/+/ /;
  $field_val=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
 $DATA{$field_name}=$field_val;
}

if($DATA{'acctnum'}){
  ($acct_num,$sf)=split(/-/,$DATA{'acctnum'});
  $style=$slist[$sf-1]; #always used except pwchange
}else{
  $acct_num=0;
  $style="$DATA{'style'}";
}

if($style eq ''){
  $style="$slist[0]";
}
$dbp="$CFG{'acct_dir'}/$style";
&get_date;
@CTRL=();
@ACCT=();
@swapbans=();
@paidbans=();
@dellist=();


&send_header("ADMIN RESULTS FOR: $command ");

if($DATA{'command'}){
    $command="$DATA{'command'}"; #always used
}else{
 print "<h3>No command selected...</h3>\n";
 &send_footer;
 &end;
}



if((&get_ctrl_data("$dbp")==0)&&($command ne 'Create Style Databases')){
 print "Error loading control dat file \"$dbp/.control.file\"...<P>\n";
 &send_footer;
 &end;
}

$cnt=0;

$skc=&style_index("$style");
$kc="$skc";

$badrefer="$DATA{'host'}";

$password="$DATA{'password'}"; #always used
$newpass="$DATA{'newpass'}"; #only valid if changing

if($DATA{'auto_expire'}){
 $auto_expire="$DATA{'auto_expire'}"; 
} #only when changing credits

$pok=0;
&check_pw;

if($pok != 1){
&invalid_pass;
&end;
}

#################
#CHECK COMMANDS

##
if($command eq 'CONF'){
 &config;
 &end;
}
##
if($command eq 'Backup'){
&backup;
&end;
}
##
if($command eq 'EditPricing'){
&edit_pricing;
&end;
}
##
if($command eq 'NewAccounts'){
 &new_accounts;
 &end;
}
if($command eq 'SavePricing'){
&save_pricing;
&end;
}
##
if($command eq 'DELnalog'){
  if(-e "$CFG{'acct_dir'}/newaccounts.txt"){
    open(NALOG,">$CFG{'acct_dir'}/newaccounts.txt") or &send_error("$!");
    print NALOG "";
    close(NALOG);
   print "'newaccounts.txt' Log has been cleared.";  
  }else{
   print "File could not be found.";
  }
}
#######
# LOGIN
if($command eq 'login'){
&login;
&end;
}
##
if($command eq 'scan_cookies'){
&scan_cookies;
&end;
}
##
if($command eq 'Member_Maint'){
 &maint;
&end;
}
##
if($command eq 'Member_Reports'){
 &reports;
&end;
}
##
if($command eq 'Statistics'){
&stats;
&end;
}
##
if($command eq 'MISC'){
&misc;
&end;
}
##
if($command eq 'MultiCodes'){
 &multi_codes("$dbp","$acct_num");
&end;
}
##
if($command eq 'ForceRescan'){
 $debug=1;
 &rescan("$dbp");
  &end;
 }
##
if($command eq 'Delete User Account'){
if($acct_num ne ''){
 &del_user;
}else{
 print "No account number\n";
}
}
##
if($command eq 'Show Banners'){
 &show_banners;
}
##
if($command eq 'Hold User Account'){
if($acct_num ne ''){
&hold_acct;
}else{
 print "No account number\n";
}
}
##
if($command eq 'Activate User Account'){
if($acct_num ne ''){
&activate;
}else{
 print "No account number\n";
}
}
##
if($command eq 'List Users'){
$style="$DATA{'style'}";
&list_users;
}
##
if($command eq 'List Hold'){
$style="$DATA{'style'}";
&list_hold;
}
##
if($command eq 'Create Style Databases'){
$style="$DATA{'style'}";
 &create_style;
}
##
if($command eq 'Get User Stats'){
if($acct_num ne ''){
&get_user_stats;
}else{
 print "No account number\n";
}
}
##
if($command eq 'Add Bad Referer'){
&add_badboy;
}
##
if($command eq 'List Bad Referers'){
&list_badboys;
}
##
if($command eq 'Store Users Banner'){
     if(&get_acct($dbp,$acct_num)==1){
        if($CFG{'use_upload'}==1){  
         $rs=&fetch_banner("$dbp","$ACCT[$IMAGE]","$acct_num");
          if($rs==1){
           $ext=substr("$ACCT[$IMAGE]",rindex("$ACCT[$IMAGE]",".")+1);
print <<"PAGE";
<CENTER>
<h1>Banner Manager<sup><font size=-1> 2.5</font></sup></h1>
<table border=0 bgcolor="#$COLOR{'headers'}" cellpadding=5 cellspacing=0 WIDTH=600>
<TD ALIGN=middle>
<FONT SIZE=4 COLOR="#$COLOR{'header_text'}">Administration - Fetch Banner</FONT>
</TD></tr></table>
<h4>Image for account: $dbp/$acct_num </h4>
<IMG SRC=\"$CFG{'cgi_bin_path'}/bimage.cgi?$dbp/bans/$acct_num.$ext\" border=1><P>
You may need to hit reload to see the correct image...
</center>
PAGE
          }else{
           if(($rs==3)||($rs==0)){
             print "Error fetching from URL: $ACCT[$IMAGE]\n\n";
           }
           if($rs==2){
             print "Error: Image at URL: $ACCT[$IMAGE] exceeds maximum banner size of $CFG{'max_image_size'} bytes\n\n";
           }
          }
        }else{
         print "Upload Disabled...enable in config25.pl if your server supports it\n";
        }
     }else{
      &send_error("Missing account number...");
     }
}

##
if($command eq 'Grant Hits To User'){
if($acct_num ne ''){
&grant_hits;
}else{
 print "No account number\n";
}
}
##
if($command eq 'Change Admin Password'){
&change_pw;
}
##
if(($command eq 'Type2paid')||($command eq 'Type2swap')||($command eq 'Type2paidhold')||($command eq 'Type2swaphold')){
&change_type;
}
##
if(($command eq 'Type2click')||($command eq 'Type2sponsor')||($command eq 'Type2clickhold')||($command eq 'Type2sponsorhold')){
&change_type;
}
##
if($command eq 'Change Default Banner'){
&change_banner;
}
##
if(($command eq 'Bulk Mail')||($command eq 'Bulk Email')){
print <<"WEB_PAGE";
<CENTER>
<h1>Banner Manager<sup><font size=-1> 2.5</font></sup></h1>
<table border=0 bgcolor="#$COLOR{'headers'}" cellpadding=5 cellspacing=0 WIDTH=600>
<TD ALIGN=middle>
<FONT SIZE=4 COLOR="#$COLOR{'header_text'}">Administration - Bulk Emailer</FONT>
</TD></tr></table>
</center>
<HR>
<B>This form bulk mails the entered text to ALL of the members in a single selected style.</b>
<P>
This bulk emailer utility skips deleted accounts, also.
<P>
<FORM METHOD="POST" ACTION="banmail.cgi">
<input type="hidden" name="password" value="$DATA{'password'}">
SELECT THE STYLE:<BR>
<SELECT NAME="style" SIZE="6">
WEB_PAGE

foreach $st(@slist){
    print "<OPTION> $st\n";
}
print <<"WEB_PAGE";
</SELECT>
ENTER YOUR MESSAGE:<BR>
<TEXTAREA NAME="message" ROWS="15" COLS="50"></TEXTAREA>
<INPUT TYPE="submit" VALUE="Send"  > 
<BR>
(May take a while to process, depending on the number of members.)
WEB_PAGE
}
##
#######################
&send_footer;
&end;
###################
# END#
######

##########################
sub change_type{
if($acct_num ne ''){
if(&get_acct($dbp,$acct_num)==0){
 print "Error loading account $dbp/$acct_num.dat...<P>\n";
 &send_footer;
 &end;
}
print "Changed from: $ACCT[$TYPE] to: ";
if($command eq 'Type2paid'){  $ACCT[$TYPE]="paid"; }
if($command eq 'Type2paidhold'){ $ACCT[$TYPE]="paidhold"; }
if($command eq 'Type2swap'){ $ACCT[$TYPE]="swap"; }
if($command eq 'Type2swaphold'){ $ACCT[$TYPE]="swaphold"; }
if($command eq 'Type2click'){  $ACCT[$TYPE]="click"; }
if($command eq 'Type2clickhold'){ $ACCT[$TYPE]="clickhold"; }
if($command eq 'Type2sponsor'){ $ACCT[$TYPE]="sponsor"; }
if($command eq 'Type2sponsorhold'){ $ACCT[$TYPE]="sponsorhold"; }
print "$ACCT[$TYPE] <BR>\n";
  if(&save_acct($dbp,$acct_num)==0){
    print "Error saving account $dbp/$acct_num.dat...<P>\n";
  }
}else{
 print "No account number\n";
}
$debug=0;
&rescan("$dbp");
}
#########################
sub create_style{
  $no_error=1;
  $ec=mkdir($CFG{'acct_dir'},0777);
   if($ec==1){
    print "<B>Database directory</B> \'$CFG{'acct_dir'}\' <B>created...</B><BR>\n";
   }
    `chmod $CFG{'dir_permissions'} $CFG{'acct_dir'}`;

  chdir($CFG{'acct_dir'});

  if(!(-e "bans.tc")){
    open(BC,">bans.tc");
    print BC "0,0";
    close(BC);
     print "<B>Exchange Stats File</B> \'bans.tc\' <B>created...</B><BR>\n";
  }
    `chmod $CFG{'file_permissions'} bans.tc`;

  if(!(-e "daily.imp")){
    open(BC,">daily.imp");
    print BC "0";
    close(BC);
     print "<B>Daily Stats File</B> \'daily.imp\' <B>created...</B><BR>\n";
  }
    `chmod $CFG{'file_permissions'} daily.imp`;

  if(!(-e "daily.clk")){
    open(BC,">daily.clk");
    print BC "0";
    close(BC);
     print "<B>Daily Stats File</B> \'daily.clk\' <B>created...</B><BR>\n";
  }
    `chmod $CFG{'file_permissions'} daily.clk`;

  $ec=mkdir($style,0777);
   if($ec==1){
    print "<B>Database directory</B> \'$dbp\' <B>created...</B><BR>\n";
   }
    `chmod $CFG{'dir_permissions'} $style`;

     chdir($style);

   if($CFG{'use_upload'}==1){
     $ec=mkdir("bans",0777);
      if($ec==1){
        print "<B>Image upload directory</B> \'$dbp/bans\' <B>created...</b><BR>\n";
      }
    `chmod $CFG{'dir_permissions'} bans`;
   }
  
   $ec=mkdir("clk",0777);
      if($ec==1){
       print "<B>Click-thru directory</B> \'$dbp/clk\' <B>created...</b><BR>\n";
      }
    `chmod $CFG{'dir_permissions'} clk`;
   
   $ec=mkdir("MC",0777);
     if($ec==1){
      print "<B>Multi-code directory</B> \'$dbp/MC\' <B>created...</b><BR>\n";
     }
    `chmod $CFG{'dir_permissions'} MC`;
 chdir("..");
 chdir("..");

  @CTRL=('0','0','0','9999','0','0','0','0','0');
   if(&save_ctrl_data("$dbp")==1){
    print "Control file\: $dbp/.control.file created...<BR>\n";

   }else{
     print "Could not create $dbp/.control.file but it will be created during the next rescan<P>\n";
   }
    `chmod $CFG{'file_permissions'} $dbp/.control.file`;

if(!(-e "$dbp/imp_count_resets.dat")){
 open(NEW,">$dbp/imp_count_resets.dat") or &send_error("Could not create $dbp/imp_count_resets.dat");
 print NEW "";
 close(NEW);
}
 `chmod $CFG{'file_permissions'} $dbp/imp_count_resets.dat`;

if(!(-e "$dbp/hit_count_resets.dat")){
 open(NEW,">$dbp/hit_count_resets.dat") or &send_error("Could not create $dbp/hit_count_resets.dat");
 print NEW "";
 close(NEW);
}
 `chmod $CFG{'file_permissions'} $dbp/hit_count_resets.dat`;
#DEFAULT ACCOUNT
 $ACCT[$USER]="$CFG{'xchange_title'}";
 $ACCT[$EMAIL]="$CFG{'owner_email'}";
 $ACCT[$EXPIRE]="swap";
 $ACCT[$PASSW]="$pass";
 $ACCT[$CALLS]=0;
 $ACCT[$HITS]=0;
 $ACCT[$LINK]="$CFG{'home_page'}";
 $ACCT[$CURBAN]=0;
 $ACCT[$IMAGE]="$CFG{'default_ban_path'}";
 $ACCT[$PAGE]="$CFG{'home_page'}";
 $ACCT[$TYPE]="swap";
 $ACCT[$STAMP]="$date";
 $ACCT[$PAIDIMP]=0;
 $ACCT[$FREEIMP]=0;
 $ACCT[$CREDITS]=999999;
 $ACCT[$SITE]="N/A";
 $ACCT[$CLKGEN]=0;
 $ACCT[$STARTDATE]="$date";
 $ACCT[$LASTUPDATE]="$date";
 $ACCT[$LASTRESET]="$date";
 $ACCT[$TARGETS]="ALL";
 $ACCT[$BLOCKS]="NONE";
 $ACCT[$R1]="N/A";
 $ACCT[$R2]="N/A";
 $ACCT[$R3]="N/A";
 $ACCT[$R4]="N/A";
&save_acct("$dbp","0");

if($no_error){ 
 print "<B>Default banner account</B> $dbp/0.dat <B>created</B><BR>\n";
  $url="$CFG{'default_ban_path'}";
 if($CFG{'use_upload'}==1){
  $acct_num="0";
  $ext=substr($url,rindex($url,".")+1);
  &fetch_banner("$dbp","$url","0");
  print "<IMG SRC=\"$CFG{'cgi_bin_path'}/bimage.cgi?$dbp/bans/0.$ext\"><br clear=all>";
 }else{
  print "<IMG SRC=\"$url\"><br clear=all>";
 }
  print "If the above image is broken, check your default_ban_path, and uplaoding abilities, and retry.";
}
 open(NEW,">$dbp/.activity.log") or &send_error("Could not create $dbp/.activity.log");
 print NEW "Activity Log Created: $date\n";
 close(NEW);
 `chmod $CFG{'file_permissions'} $dbp/.activity.log`;
 if(-e "$dbp/.activity.log"){
  print "<BR>Activity log created.<BR>";
 }
}
#######################
sub get_user_stats{
   if(&get_acct($dbp,$acct_num)==0){
      print "Could not open $dbp/$acct_num...<P>";
     &send_footer;
     &end;
   }
 $ext=substr($ACCT[$IMAGE],rindex($ACCT[$IMAGE],".")+1);
  if($CFG{'use_upload'}==1){
    $img_url="$CFG{'cgi_bin_path'}/bimage.cgi?$dbp/bans/$acct_num.$ext";
  }else{
    $img_url="$ACCT[$IMAGE]";
  }
print <<"WEB_PAGE";
<H3>Member Statistics</h3>
For account number: <B> $acct_num - $kc </B>
<HR moshade>
Username: $ACCT[$USER]<BR>
Email: <a href="mailto:$ACCT[$EMAIL]">$ACCT[$EMAIL]</a><BR>
Auto-Expire as: $ACCT[$EXPIRE]<BR>
Impressions: $ACCT[$CALLS]<BR>
Click-thrus: $ACCT[$HITS]<BR>
Link URL: <a href="$ACCT[$LINK]">$ACCT[$LINK]</a><BR>
Banner URL: <a href="$ACCT[$IMAGE]">$ACCT[$IMAGE]</a> | <a href="$img_url">Show image</a><BR>
Page URL: <a href="$ACCT[$PAGE]">$ACCT[$PAGE]</a><BR>
Account type/status: $ACCT[$TYPE]<BR>
Paid Banners shown on their page: $ACCT[$PAIDIMP]<BR>
Free Banners shown on their page: $ACCT[$FREEIMP]<BR>
Click-thrus generated from their page: $ACCT[$CLKGEN]<BR>
Available credits: $ACCT[$CREDITS]<BR>
<hr noshade>
<B>Start Date:</B> $ACCT[$STARTDATE]\t
<B>Last Update:</B> $ACCT[$LASTUPDATE]\t
<B>Last Counter Reset:</B> $ACCT[$LASTRESET]<BR>
<B>Site Category:</B> $ACCT[$SITE]<BR>
<B>Sites Targeted:</B> $ACCT[$TARGETS]<BR>
<B>Sites Blocked:</B> $ACCT[$BLOCKS]<BR>
WEB_PAGE
}
##############################
sub add_badboy{
    if(-e "badboys.dat"){
    open(BB,">>badboys.dat")||&send_error("Could not open badboys.dat :$!"); 
    print BB "$badrefer\n";
    close(BB);
  print "$badrefer added to badboy list<BR>\n";
  }
}
########################
sub list_badboys{
if(-e "badboys.dat"){
 open(BB,"badboys.dat")||&send_error("Could not open badboys.dat :$!"); 
   while($line=<BB>){
     print "$line<BR>\n";
   }
 close(BB);
}else{
   open(BB,">badboys.dat");
   print BB "noone\@nowhere.com"; 
   close(BB);
`chmod $CFG{'file_permissions'} badboys.dat`;
    print "File did not exist, but has been created....\n";
 }
}
##################################
sub grant_hits{
  &get_acct($dbp,$acct_num);
  $add_em=$DATA{'credits'};
  $ACCT[$EXPIRE]="$auto_expire";
  $ACCT[$CREDITS]=$ACCT[$CREDITS] + $add_em;
  &save_acct($dbp,$acct_num);
print "$add_em Credits were added to user account number $acct_num - $kc<BR>\n";
print "Total available credits for user: $ACCT[$USER] are now: $ACCT[$CREDITS]<BR>\n";
print "<BR>Autoexpire Set to: $ACCT[$EXPIRE]\n";
$debug=0;
&rescan("$dbp");
}

###################
sub del_user{
 &log_activity("$dbp","$acct_num","DELETED");
#############
#P23A001
 open(LOG,">>$dbp/imp_count_resets.dat");
 print LOG "$acct_num,$ACCT[$CALLS],$date\n";
 close(LOG);
 $ACCT[$CALLS]=0;
 $ACCT[$LASTRESET]="$date";

 $ext_msg .="Hits to date $ACCT[$HITS] (reset)";
 open(LOG,">>$dbp/hit_count_resets.dat");
 print LOG "$acct_num,$ACCT[$HITS],$date\n";
 close(LOG);
 $ACCT[$HITS]=0;
 $ACCT[$LASTRESET]="$date";
 &save_acct("$dbp","$acct_num");
#p23a001
#############
 
 if($CFG{'retain_files'}==0){
   if(-e "$dbp/$acct_num.dat"){
    unlink("$dbp/$acct_num.dat");
   }
   print "Account $dbp/$acct_num deleted...<P>";
 }else{
  &get_acct("$dbp","$acct_num");
  $ACCT[$TYPE]="deleted";
  &save_acct("$dbp","$acct_num");
 }
 &send_footer;
$debug=0;
&rescan("$dbp");
&end;
}

###############
sub hold_acct{
&get_acct("$dbp","$acct_num");
 if($ACCT[$TYPE] eq 'paidhold'){ $ACCT[$TYPE]="paid"; }
 if($ACCT[$TYPE] eq 'swaphold'){ $ACCT[$TYPE]="swap"; }
 if($ACCT[$TYPE] eq 'sponsorhold'){ $ACCT[$TYPE]="sponsor"; }
 if($ACCT[$TYPE] eq 'clickhold'){ $ACCT[$TYPE]="click"; }
$ACCT[$TYPE] .="hold";
&save_acct("$dbp","$acct_num");
print "User account $acct_num - $kc on hold\n";
$debug=0;
&rescan("$dbp");
}

#################
sub activate{
&get_acct($dbp,$acct_num);
 if($ACCT[$TYPE] eq 'paidhold'){ $ACCT[$TYPE]="paid"; }
 if($ACCT[$TYPE] eq 'swaphold'){ $ACCT[$TYPE]="swap"; }
 if($ACCT[$TYPE] eq 'sponsorhold'){ $ACCT[$TYPE]="sponsor"; }
 if($ACCT[$TYPE] eq 'clickhold'){ $ACCT[$TYPE]="click"; }
&save_acct($dbp,$acct_num);
print "User: $user Account: $acct_num - $kc activated as: $ACCT[$TYPE]\n";
$debug=0;
&rescan("$dbp");
}
#####################

#############
sub send_error{
  local($error_code)=@_;
$no_error=0;
print "Error: $error_code<BR> \n";
}
#############
sub post_error{
print "There was an error executing; \[ $command \] \n";
print "Error: $! \n";
}
################
sub check_pw{
open(PW,"<pw.dat");
$pass=<PW>;
close(PW);
 $test_pw=crypt($password,substr($CFG{'encrypt_key'},0,2));
 if(!($test_pw eq $pass)){
 $pok=0;
 &invalid_pass;
}else{
 $pok=1;
}
}
###################
sub invalid_pass{

print <<"WEBPAGE";
<HTML>
<HEAD><TITLE>Banner Manager Administrator Login</TITLE>
</HEAD>
<BODY BGCOLOR="#ffffff" TEXT="#000000" LINK="#000080" ALINK="#0000ff" VLINK="#000000">
<CENTER>
<h2>Banner Manager 2.5</h2>
<h4>LOGIN</h4>
<P>
<font color="ff0000"><B>INVALID PASSWORD</B></font>
<P>
<FORM METHOD="POST" ACTION="$CFG{'cgi_bin_path'}/badmin.cgi">
<B>Enter Your Admin Password</B>
 <BR>
<input type="text" name="password" value="$DATA{'password'}" size=20 maxlength=20> <BR>
<INPUT TYPE="submit" VALUE="Login" > 

<INPUT TYPE="hidden" NAME="command" VALUE="login" > 
</FORM>
</CENTER>
</BODY>
</HTML>
WEBPAGE
&end;
}
##################
sub change_pw{
$np=crypt($newpass,substr($CFG{'encrypt_key'},0,2));
open(PW,">pw.dat");
print PW "$np";
close(PW);
print "Location: $CFG{'admin_form'}\n\n";
&end;
}
################
sub get_error{
print "Error getting image from: <a href=\"$url\">$url</a><BR>\n";
print "try again or double check url via link above or Get User Stats<BR>\n";
print "Error code: $! <BR>";
print "$outfile<BR>\n";
&send_footer;
&end;
}


######################
sub change_banner{
 &get_acct($dbp,"0");
if($DATA{'bannerurl'}){
 $ACCT[$IMAGE]="$DATA{'bannerurl'}";
}
if($DATA{'linkurl'}){
 $ACCT[$LINK]="$DATA{'linkurl'}";
}

&save_acct($dbp,"0");
print "<a href=\"$ACCT[$LINK]\"><img src=\"$ACCT[$IMAGE]\" border=1></a><BR>\n";
print "<I>\[You may need to hit reload to see the new image...\]</i>\n";
}

####################################################
sub multi_codes{
  local($db_path,$acct)=@_;
$new_qty="$DATA{'allowed'}";
$qty=0;
 if(-e "$db_path/MC/1/$acct.pgd"){
    open(CNT,"<$db_path/MC/1/$acct.pgd");
    $qty=<CNT>;
    close(CNT);
 }
 open(CNT,">$db_path/MC/1/$acct.pgd");
 print CNT "$new_qty";
 close(CNT);
`chmod $CFG{'file_permissions'} $db_path/MC/1/$acct.pgd`;

print "MEMBER: $acct-$sf ,  Multi-Code Page Quantity Limit Changed From: $qty  To: $new_qty<BR>";
&send_footer;
&end;
}

##################################################
# EOS Last Update: May 12, 1998 Jeffrey L. Meyer
