#!/usr/local/bin/perl
################################################
# MeySoft Banner Manager Version 2.5F
#
# New Password Generator
#
# Copyright (c) 1997,1998 MeySoft
# Last Update: May 7, 1998
################################################
alarm(120);

require "config25.pl";
require "bm25fn.pl";

if($ENV{'REQUEST_METHOD'} eq 'POST'){
   read(STDIN,$data,$ENV{'CONTENT_LENGTH'});
}else{
 $data="$ENV{'QUERY_STRING'}";
}
@fields = split(/&/,$data);
foreach $fields(@fields){
  ($field_name,$field_val)=split(/=/,$fields);
   $field_val=~ s/\+/ /g;
   $field_val=~ s/\,/./g;
   $field_val=~ s/\&//g;
   $field_val=~ s/\"//g;
   $field_val=~ s/\'//g;
   $field_val=~ s/\`//g;
   $field_val=~ s/\*//g;
   $field_val=~ s/\\//g;
   $field_val=~ s/<!--(.|\n)*-->//g;
   $field_val=~ s/<([^>]|\n)*>//g;
   $field_val=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
 $DATA{$field_name}=$field_val;
}

@slist=split(/,/,$CFG{'slist'});
$ext_msg="";

&send_header("Lost Password");


if($DATA{'acct_num'}){
 ($acct_num,$sf)=split(/-/,$DATA{'acct_num'});
 $style=$slist[$sf-1];
 &acct_method;
}

if($DATA{'email'}){
 $email="$DATA{'email'}";
 &find_it;
}
&send_form;
exit;

##########################################################

sub acct_method{
 if(($acct_num > 0)&&($sf >0)){ 
   &get_ctrl_data("$CFG{'acct_dir'}/$style");
   if($acct_num > 999999){
      $ext_msg .= "Invalid account number";
      &send_form;
      exit;
   }
  if(-e "$CFG{'acct_dir'}/$style/$acct_num.dat"){
     &get_acct("$CFG{'acct_dir'}/$style","$acct_num");
     $newpass="T";
     $newpass .= substr("$ACCT[$EMAIL]",0,2);
     $newpass .= "$acct_num";
     $newpass .= "P$sf";
     $ACCT[$PASSW]=crypt($newpass,substr($CFG{'encrypt_key'},0,2));
     &save_acct("$CFG{'acct_dir'}/$style","$acct_num");

$email="$ACCT[$EMAIL]";

open(MAIL,"|$CFG{'mail_prog'} -t")||die "$!";
print MAIL "To: $email\n";
print MAIL "From: $CFG{'owner_email'}\n";
print MAIL "Subject: New Password\n\n";
print MAIL "Your account $acct_num-$sf has been assigned a new password by request.\n\n";
print MAIL "The new password is: $newpass\n\n";
print MAIL "Be sure to enter it exactly as it appears above, including upper/lowercase.\n";
print MAIL "Once you have logged in, you can change your password from the update form.\n";
print MAIL "\n.\n";
close(MAIL);

     &send_page;
    exit;
  }else{
   $ext_msg .="$CFG{'acct_dir'}/$style/$acct_num.dat  - File not found...";
   &send_form;
  }
 }
}
##########################################################
sub find_it{

    @aclist=();
   $email=~ s/\n//g;
  foreach $style(@slist){
   &get_ctrl_data("$CFG{'acct_dir'}/$style");
    print "Checking $style list...<P>";
     for($acct_num=0; $acct_num < $CTRL[2]; $acct_num++){
        &get_acct("$CFG{'acct_dir'}/$style","$acct_num");
               $ACCT[$EMAIL]=~ s/\n//g;
            if("$email" eq "$ACCT[$EMAIL]"){
                  $sidx=&style_index("$style");
                  $acct_code="$acct_num-$sidx";
                  $newpass="T";
                  $newpass .= substr("$ACCT[$EMAIL]",0,2);
                  $newpass .= "$acct_num";
                  $newpass .= "P$sf";
                  $ACCT[$PASSW]=crypt($newpass,substr($CFG{'encrypt_key'},0,2));
                  &save_acct("$CFG{'acct_dir'}/$style","$acct_num");
                  $nc="Account number: $acct_code  New Password: $newpass";
                  push(@aclist,$nc);
                  print "$acct_code - new password assigned.<BR>";
            }
    }#end for
  }#end foreach
   open(MAIL,"|$CFG{'mail_prog'} -t")||die "$!";
   print MAIL "To: $email\n";
   print MAIL "From: $CFG{'owner_email'}\n";
   print MAIL "Subject: New Password(s)\n\n";
   print MAIL "Your account has been assigned a new password by request.\n\n";
   print MAIL "Be sure to enter it exactly as it appears including upper/lowercase.\n";
   print MAIL "Once you have logged in, you can change your password from the update form.\n\n";

     foreach $line(@aclist){
      print MAIL "$line\n\n";
     }
  print MAIL "\n.\n";
  close(MAIL);
&send_page;
exit;

}

################################################################
sub send_page{
print <<"PAGE";
<h3>Your new password is being emailed to your address on file: $email</h3>
<h4>You should receive it momentarily...</h4>
<B><I>If your new password does not work, go back and try creating another new one. This may occur when 
the server is down and could not save the new password that was generated. Also make sure you enter it 
exactly as it was given to you (case sensitive)</I></b><P>
<a href="$CFG{'member_page'}">Back To Member Login</a>
PAGE
&send_footer;

exit;
}
########################################################
sub send_form{
print <<"PAGE";
<center>
$ext_msg
<h3>To get a new password, please provide one of the following:</h3>
<P>
<FORM METHOD="POST" ACTION="../cgi-bin/password.cgi">
<B>Enter your account number</B><BR>
<INPUT TYPE="text" name="acct_num" size=10 maxlength=10><BR>
<INPUT TYPE="submit" value="Continue..."><BR>
</FORM>
<P>
<h1>OR:</H1>

<FORM METHOD="POST" ACTION="../cgi-bin/password.cgi">
<B>Enter your email address</B><BR>
<INPUT TYPE="text" name="email" size=40 maxlength=100><BR>
<INPUT TYPE="submit" value="Search For Account"><BR>
</FORM>
<BR>
<h2>Your new password will be emailed to the address on file.</h2>
<B><I>If you have more than one account with the same <BR>
email address that you provided above, all accounts will be<BR>
assigned a new password. (This does not apply if you<BR>
provide the account number)</i></B>
</center>
PAGE
&send_footer;
}
